<template>
  <div class="dialog-box" style="position: relative">
    <el-scrollbar class="custom-scroll content-box">
      <el-form
        ref="formEditTourImMemberRef"
        :model="formData"
        :size="layoutStore.defaultFormItemSize"
        :rules="rules"
        label-width="120px"
        label-position="right"
        @submit.prevent
      >
        <el-row :gutter="16">
          <el-col :span="12">
            <el-form-item label="删除标记 " prop="TourImMember.dataState">
              <el-input-number
                class="input-item"
                v-model="formData.TourImMember.dataState"
                placeholder=""
                :clearable="true"
                :step="1"
                :controls="true"
              />
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
    </el-scrollbar>
    <el-row class="footer-box" type="flex" justify="end" align="middle">
      <el-button :size="layoutStore.defaultFormItemSize" @click="onCancel()">取消</el-button>
      <el-button :size="layoutStore.defaultFormItemSize" type="primary" @click="onSubmitTourImMemberClick()">保存</el-button>
    </el-row>
  </div>
</template>

<script lang="ts">
export default {
  name: 'formEditTourImMember',
};
</script>

<script setup lang="ts">
import { DialogProp } from '@/components/Dialog/types';
import { VxeColumn, VxeTable } from 'vxe-table';
import { ANY_OBJECT } from '@/types/generic';
import { DictData, DictionaryBase } from '@/common/staticDict/types';
import { ElMessage, ElMessageBox, UploadFile } from 'element-plus';
import { useRoute, useRouter } from 'vue-router';
import { useCommon } from '@/common/hooks/useCommon';
import { useLayoutStore, useStaticDictStore } from '@/store';
import { useDownload } from '@/common/hooks/useDownload';
import { useDropdown } from '@/common/hooks/useDropdown';
import { DropdownOptions, ListData } from '@/common/types/list';
import { useTable } from '@/common/hooks/useTable';
import { TableOptions } from '@/common/types/pagination';
import { useUpload } from '@/common/hooks/useUpload';
import { useUploadWidget } from '@/common/hooks/useUploadWidget';
import { DictionaryController } from '@/api/system';
import { treeDataTranslate, findItemFromList, findTreeNodePath, findTreeNode, stringCase } from '@/common/utils';
import { TourImMemberData } from '@/api/generated/tourImMemberController';
import { TourImMemberController } from '@/api/generated';

const router = useRouter();
const route = useRoute();
const layoutStore = useLayoutStore();
const { downloadFile } = useDownload();
const { getUploadHeaders, getUploadActionUrl, fileListToJson, parseUploadData, getPictureList } = useUpload();
const { 
  Delete,
  Search,
  Edit,
  Plus,
  Refresh,
  Picture,
  Dialog,
  mainContextHeight,
  clientHeight,
  checkPermCodeExist,
  parseParams,
  parseArrayParams,
  formatDateByStatsType,
  getDateRangeFilter,
} = useCommon();
// 静态字典
const { staticDict: StaticDict } = useStaticDictStore();

const props = withDefaults(
  defineProps<{
    subPage?: number | string | boolean;
    id?: ANY_OBJECT;
    saveOnSubmit?: boolean;
    rowData?: ANY_OBJECT;
    // 当使用Dialog.show弹出组件时，须定义该prop属性，以便对dialog进行回调
    dialog?: DialogProp<ANY_OBJECT[]>;
  }>(),
  {
    subPage: 0,
    id: undefined,
    saveOnSubmit: true,
    rowData: undefined,
    dialog: undefined,
  },
);

const formEditTourImMemberRef = ref();
// 表单数据定义
type FormEditTourImMemberData = {
  TourImMember: TourImMemberData;
};
// 表单数据
const formData = reactive<FormEditTourImMemberData>({
  TourImMember: {
    // id
    id: undefined,
    // 聊天群组id
    groupId: undefined,
    // 成员角色 1群主 2管理员 3普通成员
    groupRole: undefined,
    // 用户id
    userId: undefined,
    // 会话是否显示(每个群在聊天列表要不要展示) 0不显示 1显示
    isShow: undefined,
    // 会话是否置顶 (每个群在聊天列表要不要置顶)  0不置顶 1 置顶
    isTop: undefined,
    // 会话是否开启免打扰 0不开启免打扰 1 开启免打扰
    isNotDisturb: undefined,
    // 自己在群里的昵称
    groupNickname: undefined,
    // 群备注
    groupRemark: undefined,
    // 删除标记 1正常 -1删除
    dataState: undefined,
    // 聊天背景
    groupBackImage: undefined,
    // 创建人id
    createUserId: undefined,
    // 创建时间
    createTime: undefined,
    // 更新时间
    updateTime: undefined,
    // 更新人id
    updateUserId: undefined,
  },
},
);
// 表单验证规则
const rules = reactive({
  'TourImMember.dataState': [
    {required: true, message: '请输入删除标记 ', trigger: 'blur'}
  ],
});

const onCancel = () => {
  if (props.dialog) {
    props.dialog.cancel();
  }
};

const isEdit = computed(() => {
  return props.saveOnSubmit ? props.id != null : props.rowData != null;
});

// 初始化页面数据
const loadTourImMemberData = () => {
  return new Promise<void>((resolve, reject) => {
    if (!isEdit.value) {
      resolve();
      return;
    }
    if (!props.saveOnSubmit && props.rowData != null) {
      formData.TourImMember = JSON.parse(JSON.stringify(props.rowData));
      resolve();
      return;
    }
    let params: ANY_OBJECT = {
      id: props.id
    };
    TourImMemberController.view(params).then(res => {
      formData.TourImMember = { ...res.data };
      resolve();
    }).catch(e => {
      reject(e);
    });
  });
};
const onUploadError = () => {
  ElMessage.error('文件上传失败');
};
const onUploadLimit = () => {
  ElMessage.error('已经超出最大上传个数限制');
};
const refreshFormEditTourImMember = () => {
  // 刷新段落
};
/**
 * 重置过滤值
 */
const resetFormEditTourImMember = () => {
  refreshFormEditTourImMember();
};
/**
 * 重置所有过滤值
 */
const resetFilter = () => {
  resetFormEditTourImMember();
};
/**
 * 保存
 */
const onSubmitTourImMemberClick = () => {
  formEditTourImMemberRef.value.validate((valid) => {
    if (!valid) return;
    // 级联操作
    if (!props.saveOnSubmit) {
      let retFormData = {
        ...formData.TourImMember
      };
  props.dialog?.submit(retFormData);
      return;
    }
    let params: ANY_OBJECT = {
      tourImMemberDto: {
        id: formData.TourImMember.id,
        groupId: formData.TourImMember.groupId,
        groupRole: formData.TourImMember.groupRole,
        isShow: formData.TourImMember.isShow,
        isTop: formData.TourImMember.isTop,
        isNotDisturb: formData.TourImMember.isNotDisturb,
        groupNickname: formData.TourImMember.groupNickname,
        groupRemark: formData.TourImMember.groupRemark,
        createUserId: formData.TourImMember.createUserId,
        createTime: formData.TourImMember.createTime,
        updateTime: formData.TourImMember.updateTime,
        updateUserId: formData.TourImMember.updateUserId,
      }
    };

    let httpCall = isEdit.value ? TourImMemberController.update : TourImMemberController.add;
    httpCall(params).then(res => {
      ElMessage.success('保存成功');
      props.dialog?.submit();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
  });
};
const formInit = () => {
  loadTourImMemberData().then(res => {
    if (isEdit.value) refreshFormEditTourImMember();
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};

onMounted(() => {
  formInit();
});
</script>
